
// Name
//===================================
//
// BlockSystem
//


// DEPENDENCIES
//===================================

    #include "block_system.h"
    #include "block_type.h"
    #include "camera.h"
    #include "graphics.h"
    #include <iostream>
    #include "map.h"
    #include "sprite.h"
    #include "sprite_graphics.h"


// STATIC VARIABLES
//===================================


// METHODS
//===================================

    BlockSystem::BlockSystem()
    {
        block_types_ =
        {
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 12*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 13*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 12*8, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 13*8, 8 ),
                BlockType::BlockAction::GEM
            ),
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 0, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 0 ),
                BlockType::BlockAction::SOLID
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 8 ),
                BlockType::BlockAction::SOLID
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 24, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 24, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 24, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 24, 0 ),
                BlockType::BlockAction::__NULL
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 32, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 40, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 32, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 40, 8 ),
                BlockType::BlockAction::SOLID
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 64, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 72, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 64, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 72, 8 ),
                BlockType::BlockAction::CLIMBABLE
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 80, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 88, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 80, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 88, 8 ),
                BlockType::BlockAction::__NULL
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 14*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 15*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 17*8, 0 ),
                BlockType::BlockAction::__NULL
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 22*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 23*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 23*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 22*8, 0 ),
                BlockType::BlockAction::SOLID
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 23*8, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 24*8, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 0 ),
                BlockType::BlockAction::__NULL
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 25*8, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 26*8, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 0 ),
                BlockType::BlockAction::__NULL
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 22*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 23*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 24*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 25*8, 0 ),
                BlockType::BlockAction::SOLID
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 29*8, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 30*8, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 29*8, 16 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 30*8, 16 ),
                BlockType::BlockAction::HURT
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 31*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 31*8, 0, true ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 31*8, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 31*8, 8, true ),
                BlockType::BlockAction::__NULL
            ),
            nullptr,
            nullptr,
            nullptr,
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 9*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 9*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 24, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 24, 0 ),
                BlockType::BlockAction::FLAT_TOP
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 24, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 24, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 64, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 64, 0 ),
                BlockType::BlockAction::__NULL
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 18*8, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 18*8, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 18*8, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 18*8, 8 ),
                BlockType::BlockAction::__NULL
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 19*8, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 19*8, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 18*8, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 18*8, 8 ),
                BlockType::BlockAction::FLAT_TOP
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 18*8, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 18*8, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 20*8, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 20*8, 8 ),
                BlockType::BlockAction::__NULL
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 21*8, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 22*8, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 21*8, 16 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 22*8, 16 ),
                BlockType::BlockAction::__NULL
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 18*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 19*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 20*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 21*8, 0 ),
                BlockType::BlockAction::__NULL
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 6*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 7*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 22*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 23*8, 0 ),
                BlockType::BlockAction::SOLID
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 27*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 28*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 2*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 2*8, 0 ),
                BlockType::BlockAction::SOLID
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 29*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 30*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 2*8, 0 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 2*8, 0 ),
                BlockType::BlockAction::SOLID
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 27*8, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 28*8, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 27*8, 16 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 28*8, 16 ),
                BlockType::BlockAction::SOLID
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 0, 16 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 8, 16 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 0, 24 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 8, 24 ),
                BlockType::BlockAction::GOAL
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 31*8, 16 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 31*8, 16, true ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 31*8, 16 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 31*8, 16, true ),
                BlockType::BlockAction::__NULL
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 40, 24 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 40, 24 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 40, 24 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 40, 24 ),
                BlockType::BlockAction::SOLID
            ),
            nullptr,
            nullptr,
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 8 ),
                BlockType::BlockAction::WARP1
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 8 ),
                BlockType::BlockAction::WARP2
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 8 ),
                BlockType::BlockAction::WARP3
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 8 ),
                BlockType::BlockAction::WARP4
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 16, 8 ),
                BlockType::BlockAction::WARP5
            ),
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            nullptr,
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 64, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 72, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 64, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 72, 8 ),
                BlockType::BlockAction::WARP1
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 64, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 72, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 64, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 72, 8 ),
                BlockType::BlockAction::WARP2
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 64, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 72, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 64, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 72, 8 ),
                BlockType::BlockAction::WARP3
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 64, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 72, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 64, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 72, 8 ),
                BlockType::BlockAction::WARP4
            ),
            new BlockType
            (
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 64, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 72, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 64, 8 ),
                new SpriteGraphics( Graphics::SpriteSheet::LVTILESET_CITY, 72, 8 ),
                BlockType::BlockAction::WARP5
            )

        };
    };

    BlockSystem::~BlockSystem()
    {
        clearBlockTypes();
    };

    void BlockSystem::update( Camera& camera, Input& input )
    {
    };

    void BlockSystem::render( Graphics& graphics, Camera& camera, bool priority )
    {
        for ( int i = 0; i < blocks_used_; ++i )
        {
            blocks_[i].render( graphics, camera );
        }
    };

    void BlockSystem::clearBlocks()
    {
        for (int i = 0; i < blocks_used_; ++i)
        {
            blocks_[i].neutralize();
        }

        blocks_used_ = 0;
    };

    void BlockSystem::addBlock( int x, int y, BlockType* type, int location )
    {
        if ( blocks_used_ < LIMIT )
        {
            blocks_[ blocks_used_ ].setBlock( x, y, type, location );
            ++blocks_used_;
        }
    };

    void BlockSystem::collide( Sprite& sprite, Level& level, EventSystem& events, Inventory& inventory, Camera& camera, GameState* state, Graphics& graphics )
    {
        for (int i = 0; i < blocks_used_; ++i)
        {
            sprite.collisionDetect( blocks_[i], level, events, inventory, camera, state, graphics );
        }
    };

    void BlockSystem::blocksFromMap( Map& lvmap, Camera& camera )
    {
        if ( camera.changed() || lvmap.changed() )
        {
            clearBlocks();

            SDL_Rect bc = { 0, 0, 16, 16 };

            for ( int i = 0; i < lvmap.blocksSize(); ++i )
            {
                bc.x = Unit::BlocksToPixels( lvmap.mapX( i ) );
                bc.y = Unit::BlocksToPixels( lvmap.mapY( i ) );

                if ( camera.onscreen( bc, 16 ) )
                {
                    const int type = lvmap.block( i ) - 1;

                    if ( type > -1 )
                    {
                        addBlock( bc.x, bc.y, blockType( type ), i );
                    }
                }
            }
        }

        lvmap.update();
    };

    BlockType* BlockSystem::blockType( int n ) const
    {
        if ( n > -1 && n < block_types_.size() )
        {
            return block_types_[ n ];
        }
        else
        {
            return nullptr;
        }
    };

    void BlockSystem::clearBlockTypes()
    {
        for ( auto i : block_types_ )
        {
            delete i;
        }
    };
