


// Name
//===================================
//
// BlockType
//


// DEPENDENCIES
//===================================

    #include "block.h"
    #include "block_type.h"
    #include <iostream>
    #include "sprite_graphics.h"


// STATIC PROPERTIES
//===================================

// METHODS
//===================================

    BlockType::BlockType
    (
        SpriteGraphics* g1,
        SpriteGraphics* g2,
        SpriteGraphics* g3,
        SpriteGraphics* g4,
        BlockAction action
    )
    :
        graphics_ ( { g1, g2, g3, g4 } ),
        action_ ( action )
    {};

    BlockType::~BlockType()
    {
        for ( int i = 0; i < NUM_O_MINI_BLOCKS; ++i )
        {
            delete graphics_[ i ];
        }
    };

    void BlockType::collide( Sprite& sprite, Collision& collision )
    {
    };

    void BlockType::render( Graphics& graphics, Camera& camera, Block& block )
    {
        SDL_Rect r = { 0, 0, 8, 8 };

        for ( int i = 0; i < NUM_O_MINI_BLOCKS; ++i )
        {
            int x = ( i % 2 ) * 8;
            int y = floor( i / 2 ) * 8;

            r.x = block.xPixels() + x;
            r.y = block.yPixels() + y;

            graphics_[i]->render( graphics, r, &camera );
        }
    };

    const BlockType::BlockAction BlockType::action() const
    {
        return action_;
    };
