
// Name
//===================================
//
// Counter
//


// DEPENDENCIES
//===================================

    #include "counter.h"


// STATIC PROPERTIES
//===================================


// METHODS
//===================================


    Counter::Counter( int init_value, int upper_limit, int lower_limit, bool reset, bool flip )
    :
        upper_limit_ ( upper_limit ),
        lower_limit_ ( lower_limit ),
        init_value_ ( init_value ),
        value_ ( init_value ),
        reset_ ( reset ),
        flip_ ( flip )
    {};

    void Counter::operator+  ( int n )
    {
        value_ = test_value_increase( value_ + n );
    };

    void Counter::operator-  ( int n )
    {
        value_ = test_value_decrease( value_ - n );
    };

    void Counter::operator= ( int n ) { test_value_increase( test_value_decrease( n ) ); };

    void Counter::operator++ () { *this + 1; };

    void Counter::operator-- () { *this - 1; };

    int Counter::value() const { return value_; };

    int Counter::test_value_decrease( int n ) const
    {
        if ( lower_limit_ < LOWER_LIMIT_NULL )
        {
            if ( n < lower_limit_ )
                if ( reset_ )
                    return init_value_;
                else
                    return lower_limit_;
        }

        return n;
    };

    int Counter::test_value_increase( int n ) const
    {
        if ( upper_limit_ > UPPER_LIMIT_NULL )
        {
            if ( n > upper_limit_ )
            {
                if ( reset_ )
                    return init_value_;
                else
                    return upper_limit_;
            }
        }

        return n;
    };

    void Counter::reset()
    {
        value_ = init_value_;
    };
