

// Name
//===================================
//
// Map
//

#ifndef MAP_H
#define MAP_H


// FORWARD DECLARATIONS
//===================================


// DEPENDENCIES
//===================================

    #include "palette.h"
    #include <vector>


// CLASS
//===================================

    class Map
    {
        public:
            Map
            (
                std::vector<int> blocks,
                int width,
                int height,
                Palette::PaletteSet palette = { Palette::PaletteType::CLASSIC_GREEN, 2 }
            );
            ~Map();

            int widthBlocks() const;
            int heightBlocks() const;
            int widthPixels() const;
            int heightPixels() const;
            int blocksSize() const;
            int block( int n ) const;
            int mapX( int n ) const;
            int mapY( int n ) const;
            const bool changed() const;
            void changeBlock( int where, int value );
            void deleteBlock( int where );
            void update();
            Palette::PaletteSet palette() const;

        private:
            std::vector<int> blocks_;
            Palette::PaletteSet palette_;
            int width_ = 224;
            int height_ = 16;
            bool changed_ = true;

            bool inBounds( int n ) const;
    };

#endif // MAP_H
