
// Name
//===================================
//
// SpriteMovement
//

#ifndef SPRITE_MOVEMENT_H
#define SPRITE_MOVEMENT_H


// FORWARD DECLARATIONS
//===================================

    class Collision;
    class Block;
    class Camera;
    class EventSystem;
    class Game;
    class GameState;
    class Graphics;
    class Input;
    class Inventory;
    class Level;
    class Map;
    class Sprite;
    class SpriteGraphics;


// DEPENDENCIES
//===================================



// CLASS
//===================================

    class SpriteMovement
    {
        public:
            virtual ~SpriteMovement();
            virtual void update( Sprite& sprite, Input& input, Camera& camera, Map& lvmap, SpriteGraphics* graphics, Game& game, EventSystem& events ) = 0;
            virtual void collision( Collision collision, Sprite& sprite, Sprite& other ) = 0;
            virtual void collision( Collision collision, Sprite& sprite, Block& block, Level& level, EventSystem& events, Inventory& inventory, Camera& camera, GameState* state, Graphics& graphics ) = 0;
    };


#endif // SPRITE_MOVEMENT_H
